<template>
  <div class="container">
    <h1 class="title">TODOS</h1>
    <div class="columns is-multiline" v-show="todos.length">
      <div v-for="todo in todos" class="column is-one-quarter" :key="todo.id">
        <div class="box">
          <a @click="deleteTodo(todo.id)" class="is-pulled-right delete"></a>
          <span class="title is-4">{{todo.name}}</span><br>
          <span class="subtitle is-6">ID: {{todo.id}}</span><br>
            {{todo.name}}<br>
            {{todo.date_created}}<br>
            {{todo.date_modified}}<br>
        </div>
      </div>
    </div>

    <form @submit.prevent="createTodo">
      <div class="field">
        <div class="control">
          <b-field label="Name"
                   v-bind:type="{ 'is-danger' : !$v.name.required }"
                   v-bind:message="{ 'Todo can\'t be blank': !$v.name.required }">
            <b-input v-model.trim="$v.name.$model" placeholder="Gotta Do that Thing..."></b-input>
          </b-field>
        </div>
      </div>
      <button class="button is-primary is-large" type="submit">Create Todo</button>
    </form>

  </div>
</template>

<script>
import { required } from "vuelidate/lib/validators";

export default {
  data() {
    return {
      name: ""
    };
  },
  validations: {
    name: {
      required
    }
  },
  methods: {
    createTodo() {
      this.$v.$touch();
      if (this.$v.$invalid) {
        return;
      }
      const { name } = this;
      this.$store
        .dispatch("REQUEST_ADD_TODO", { name })
        .then(newTodo => {
          this.$toast.open({
            duration: 5000,
            message: `Created Todo ${newTodo.id}!`,
            type: `is-success`
          });
        })
        .catch(() => {
          this.$toast.open({
            duration: 5000,
            message: `Incorrect email or password`,
            type: `is-danger`
          });
        });
    },
    deleteTodo(id) {
      this.$store
        .dispatch("REQUEST_DELETE_TODO", id)
        .then(() => {
          this.$toast.open({
            duration: 5000,
            message: `Deleted Todo ${id}`,
            type: `is-success`
          });
        })
        .catch(() => {
          this.$toast.open({
            duration: 5000,
            message: `Could not delete todo ${id}`,
            type: `is-danger`
          });
        });
    }
  },
  computed: {
    isLoggedIn() {
      return this.$store.getters.isLoggedIn;
    },
    todos() {
      return this.$store.getters.todos;
    }
  },
  created() {
    this.$store.dispatch("REQUEST_TODOS");
  }
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">
</style>
